require '_h2ph_pre.ph';

unless(defined(&_ASMARM_PAGE_H)) {
    eval 'sub _ASMARM_PAGE_H () {1;}' unless defined(&_ASMARM_PAGE_H);
    require 'asm/arch/memory.ph';
    require 'asm/proc/page.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub get_user_page {
	    local($vaddr) = @_;
    	    eval q( &__get_free_page( &GFP_KERNEL));
	}' unless defined(&get_user_page);
	eval 'sub free_user_page {
	    local($page, $addr) = @_;
    	    eval q( &free_page($addr));
	}' unless defined(&free_user_page);
	eval 'sub clear_page {
	    local($page) = @_;
    	    eval q( &memzero(($page),  &PAGE_SIZE));
	}' unless defined(&clear_page);
	eval 'sub copy_page {
	    local($to,$from) = @_;
    	    eval q( &memcpy(, ($from),  &PAGE_SIZE));
	}' unless defined(&copy_page);
    }
    eval 'sub __pa {
        local($x) = @_;
	    eval q( &__virt_to_phys(($x)));
    }' unless defined(&__pa);
    eval 'sub __va {
        local($x) = @_;
	    eval q((( &__phys_to_virt(($x)))));
    }' unless defined(&__va);
}
1;
