require '_h2ph_pre.ph';

unless(defined(&__ASM_SOFTIRQ_H)) {
    eval 'sub __ASM_SOFTIRQ_H () {1;}' unless defined(&__ASM_SOFTIRQ_H);
    require 'asm/atomic.ph';
    require 'asm/hardirq.ph';
    eval 'sub in_bh () {
        eval q(( $local_bh_count[ &smp_processor_id()] != 0));
    }' unless defined(&in_bh);
    eval 'sub get_active_bhs () {
        eval q(( &bh_mask &  &bh_active));
    }' unless defined(&get_active_bhs);
    eval 'sub clear_active_bhs {
        local($x) = @_;
	    eval q( &atomic_clear_mask(($x), &bh_active));
    }' unless defined(&clear_active_bhs);
    if(defined(&__SMP__)) {
	die("SMP\ not\ supported");
    } else {
	eval 'sub softirq_trylock {
	    local($cpu) = @_;
    	    eval q(( &in_bh() ? 0: ( $local_bh_count[ &smp_processor_id()]=1)));
	}' unless defined(&softirq_trylock);
	eval 'sub softirq_endlock {
	    local($cpu) = @_;
    	    eval q(( $local_bh_count[ &smp_processor_id()] = 0));
	}' unless defined(&softirq_endlock);
	eval 'sub synchronize_bh () {
	    eval q( &do { }  &while (0));
	}' unless defined(&synchronize_bh);
    }
}
1;
