require '_h2ph_pre.ph';

unless(defined(&__ASM_ARM_SYSTEM_H)) {
    eval 'sub __ASM_ARM_SYSTEM_H () {1;}' unless defined(&__ASM_ARM_SYSTEM_H);
    require 'linux/kernel.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	eval 'sub __ebsa285_data () { &__attribute__(( &__section__(".data.ebsa285")));}' unless defined(&__ebsa285_data);
	eval 'sub __netwinder_data () { &__attribute__(( &__section__(".data.netwinder")));}' unless defined(&__netwinder_data);
	if(defined(&CONFIG_TEXT_SECTIONS)) {
	    eval 'sub __ebsa285_text () { &__attribute__(( &__section__(".text.ebsa285")));}' unless defined(&__ebsa285_text);
	    eval 'sub __netwinder_text () { &__attribute__(( &__section__(".text.netwinder")));}' unless defined(&__netwinder_text);
	} else {
	    eval 'sub __ebsa285_text () {1;}' unless defined(&__ebsa285_text);
	    eval 'sub __netwinder_text () {1;}' unless defined(&__netwinder_text);
	}
	eval 'sub MACH_TYPE_EBSA110 () {0;}' unless defined(&MACH_TYPE_EBSA110);
	eval 'sub MACH_TYPE_RISCPC () {1;}' unless defined(&MACH_TYPE_RISCPC);
	eval 'sub MACH_TYPE_NEXUSPCI () {3;}' unless defined(&MACH_TYPE_NEXUSPCI);
	eval 'sub MACH_TYPE_EBSA285 () {4;}' unless defined(&MACH_TYPE_EBSA285);
	eval 'sub MACH_TYPE_NETWINDER () {5;}' unless defined(&MACH_TYPE_NETWINDER);
	eval 'sub MACH_TYPE_CATS () {6;}' unless defined(&MACH_TYPE_CATS);
	eval 'sub MACH_TYPE_TBOX () {7;}' unless defined(&MACH_TYPE_TBOX);
	eval 'sub MACH_TYPE_CO285 () {8;}' unless defined(&MACH_TYPE_CO285);
	eval 'sub MACH_TYPE_CLPS7110 () {9;}' unless defined(&MACH_TYPE_CLPS7110);
	eval 'sub MACH_TYPE_ARCHIMEDES () {10;}' unless defined(&MACH_TYPE_ARCHIMEDES);
	eval 'sub MACH_TYPE_A5K () {11;}' unless defined(&MACH_TYPE_A5K);
	if(defined(&CONFIG_ARCH_EBSA110)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_EBSA110;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_ebsa110 () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_EBSA110));
	    }' unless defined(&machine_is_ebsa110);
	} else {
	    eval 'sub machine_is_ebsa110 () {
	        eval q((0));
	    }' unless defined(&machine_is_ebsa110);
	}
	if(defined(&CONFIG_ARCH_RPC)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_RISCPC;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_riscpc () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_RISCPC));
	    }' unless defined(&machine_is_riscpc);
	} else {
	    eval 'sub machine_is_riscpc () {
	        eval q((0));
	    }' unless defined(&machine_is_riscpc);
	}
	if(defined(&CONFIG_ARCH_EBSA285)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_EBSA285;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_ebsa285 () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_EBSA285));
	    }' unless defined(&machine_is_ebsa285);
	} else {
	    eval 'sub machine_is_ebsa285 () {
	        eval q((0));
	    }' unless defined(&machine_is_ebsa285);
	}
	if(defined(&CONFIG_ARCH_NETWINDER)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_NETWINDER;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_netwinder () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_NETWINDER));
	    }' unless defined(&machine_is_netwinder);
	} else {
	    eval 'sub machine_is_netwinder () {
	        eval q((0));
	    }' unless defined(&machine_is_netwinder);
	}
	if(defined(&CONFIG_CATS)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_CATS;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_cats () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_CATS));
	    }' unless defined(&machine_is_cats);
	} else {
	    eval 'sub machine_is_cats () {
	        eval q((0));
	    }' unless defined(&machine_is_cats);
	}
	if(defined(&CONFIG_ARCH_CO285)) {
	    if(defined(&machine_arch_type)) {
		undef(&machine_arch_type) if defined(&machine_arch_type);
		eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	    } else {
		eval 'sub machine_arch_type () { &MACH_TYPE_CO285;}' unless defined(&machine_arch_type);
	    }
	    eval 'sub machine_is_co285 () {
	        eval q(( &machine_arch_type ==  &MACH_TYPE_CO285));
	    }' unless defined(&machine_is_co285);
	} else {
	    eval 'sub machine_is_co285 () {
	        eval q((0));
	    }' unless defined(&machine_is_co285);
	}
	if(defined(&CONFIG_ARCH_A5K)) {
	    eval 'sub machine_is_a5000 () {
	        eval q((1));
	    }' unless defined(&machine_is_a5000);
	} else {
	    eval 'sub machine_is_a5000 () {
	        eval q((0));
	    }' unless defined(&machine_is_a5000);
	}
	if(defined(&CONFIG_ARCH_ARC)) {
	    eval 'sub machine_is_archimedes () {
	        eval q((1));
	    }' unless defined(&machine_is_archimedes);
	} else {
	    eval 'sub machine_is_archimedes () {
	        eval q((0));
	    }' unless defined(&machine_is_archimedes);
	}
	unless(defined(&machine_arch_type)) {
	    eval 'sub machine_arch_type () { &__machine_arch_type;}' unless defined(&machine_arch_type);
	}
	require 'asm/proc-fns.ph';
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub tas {
	    local($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub switch_to {
	    local($prev,$next,$last) = @_;
    	    eval q( &do { $last =  ($processor->{_switch_to})($prev,$next);  &mb(); }  &while (0));
	}' unless defined(&switch_to);
	require 'asm/proc/system.ph';
	require 'asm/arch/system.ph';
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__ (\\"\\" : : : \\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	eval 'sub nop () {
	    eval q( &__asm__  &__volatile__(\\"mov\\\\tr0,r0\\\\t@ nop\\\\n\\\\t\\"););
	}' unless defined(&nop);
    }
}
1;
