require '_h2ph_pre.ph';

unless(defined(&_LINUX_TASKS_H)) {
    eval 'sub _LINUX_TASKS_H () {1;}' unless defined(&_LINUX_TASKS_H);
    require 'linux/config.ph';
    if(defined(&__SMP__)) {
	eval 'sub NR_CPUS () {32;}' unless defined(&NR_CPUS);
    } else {
	eval 'sub NR_CPUS () {1;}' unless defined(&NR_CPUS);
    }
    if(defined(&CONFIG_SMALL_BUFFERS)) {
	eval 'sub NR_TASKS () {128;}' unless defined(&NR_TASKS);
    } else {
	eval 'sub NR_TASKS () {512;}' unless defined(&NR_TASKS);
    }
    eval 'sub MAX_TASKS_PER_USER () {( &NR_TASKS/2);}' unless defined(&MAX_TASKS_PER_USER);
    eval 'sub MIN_TASKS_LEFT_FOR_ROOT () {4;}' unless defined(&MIN_TASKS_LEFT_FOR_ROOT);
    eval 'sub PID_MAX () {0x8000;}' unless defined(&PID_MAX);
}
1;
