require '_h2ph_pre.ph';

unless(defined(&__ASM_ARM_BYTEORDER_H)) {
    eval 'sub __ASM_ARM_BYTEORDER_H () {1;}' unless defined(&__ASM_ARM_BYTEORDER_H);
    require 'asm/types.ph';
    if(defined( &__GNUC__)  && (defined(&__GNUC__) ? &__GNUC__ : 0) == 2 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 8) {
	eval 'sub __arch__swab32 {
	    local($x) = @_;
    	    eval q( &___arch__swab32($x));
	}' unless defined(&__arch__swab32);
	eval 'sub __arch__swab16 {
	    local($x) = @_;
    	    eval q( &___arch__swab16($x));
	}' unless defined(&__arch__swab16);
    }
    if(!defined( &__STRICT_ANSI__) || defined( &__KERNEL__)) {
	eval 'sub __BYTEORDER_HAS_U64__ () {1;}' unless defined(&__BYTEORDER_HAS_U64__);
	eval 'sub __SWAB_64_THRU_32__ () {1;}' unless defined(&__SWAB_64_THRU_32__);
    }
    if(defined(&__ARMEB__)) {
	require 'linux/byteorder/big_endian.ph';
    } else {
	require 'linux/byteorder/little_endian.ph';
    }
}
1;
