require '_h2ph_pre.ph';

unless(defined(&__ASM_HARDIRQ_H)) {
    eval 'sub __ASM_HARDIRQ_H () {1;}' unless defined(&__ASM_HARDIRQ_H);
    require 'linux/tasks.ph';
    eval 'sub in_interrupt () {
        eval q(( $local_irq_count[ &smp_processor_id()] +  $local_bh_count[ &smp_processor_id()] != 0));
    }' unless defined(&in_interrupt);
    unless(defined(&__SMP__)) {
	eval 'sub hardirq_trylock {
	    local($cpu) = @_;
    	    eval q(( $local_irq_count[$cpu] == 0));
	}' unless defined(&hardirq_trylock);
	eval 'sub hardirq_endlock {
	    local($cpu) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&hardirq_endlock);
	eval 'sub hardirq_enter {
	    local($cpu) = @_;
    	    eval q(( $local_irq_count[$cpu]++));
	}' unless defined(&hardirq_enter);
	eval 'sub hardirq_exit {
	    local($cpu) = @_;
    	    eval q(( $local_irq_count[$cpu]--));
	}' unless defined(&hardirq_exit);
	eval 'sub synchronize_irq () {
	    eval q( &do { }  &while (0));
	}' unless defined(&synchronize_irq);
    } else {
	die("SMP\ not\ supported");
    }
}
1;
