require '_h2ph_pre.ph';

unless(defined(&__ASSEMBLY__)) {
    eval 'sub __IOMD {
        local($offset) = @_;
	    eval q(( &IO_IOMD_BASE + ($offset >> 2)));
    }' unless defined(&__IOMD);
} else {
    eval 'sub __IOMD {
        local($offset) = @_;
	    eval q($offset);
    }' unless defined(&__IOMD);
}
unless(defined(&IOMD_CONTROL)) {
    sub IOMD_CONTROL () {	 &__IOMD(0x000);}
}
unless(defined(&IOMD_KARTTX)) {
    sub IOMD_KARTTX () {	 &__IOMD(0x004);}
}
unless(defined(&IOMD_KARTRX)) {
    sub IOMD_KARTRX () {	 &__IOMD(0x004);}
}
unless(defined(&IOMD_KCTRL)) {
    sub IOMD_KCTRL () {	 &__IOMD(0x008);}
}
unless(defined(&IOMD_IRQSTATA)) {
    sub IOMD_IRQSTATA () {	 &__IOMD(0x010);}
}
unless(defined(&IOMD_IRQREQA)) {
    sub IOMD_IRQREQA () {	 &__IOMD(0x014);}
}
unless(defined(&IOMD_IRQCLRA)) {
    sub IOMD_IRQCLRA () {	 &__IOMD(0x014);}
}
unless(defined(&IOMD_IRQMASKA)) {
    sub IOMD_IRQMASKA () {	 &__IOMD(0x018);}
}
unless(defined(&IOMD_IRQSTATB)) {
    sub IOMD_IRQSTATB () {	 &__IOMD(0x020);}
}
unless(defined(&IOMD_IRQREQB)) {
    sub IOMD_IRQREQB () {	 &__IOMD(0x024);}
}
unless(defined(&IOMD_IRQMASKB)) {
    sub IOMD_IRQMASKB () {	 &__IOMD(0x028);}
}
unless(defined(&IOMD_FIQSTAT)) {
    sub IOMD_FIQSTAT () {	 &__IOMD(0x030);}
}
unless(defined(&IOMD_FIQREQ)) {
    sub IOMD_FIQREQ () {	 &__IOMD(0x034);}
}
unless(defined(&IOMD_FIQMASK)) {
    sub IOMD_FIQMASK () {	 &__IOMD(0x038);}
}
unless(defined(&IOMD_T0CNTL)) {
    sub IOMD_T0CNTL () {	 &__IOMD(0x040);}
}
unless(defined(&IOMD_T0LTCHL)) {
    sub IOMD_T0LTCHL () {	 &__IOMD(0x040);}
}
unless(defined(&IOMD_T0CNTH)) {
    sub IOMD_T0CNTH () {	 &__IOMD(0x044);}
}
unless(defined(&IOMD_T0LTCHH)) {
    sub IOMD_T0LTCHH () {	 &__IOMD(0x044);}
}
unless(defined(&IOMD_T0GO)) {
    sub IOMD_T0GO () {	 &__IOMD(0x048);}
}
unless(defined(&IOMD_T0LATCH)) {
    sub IOMD_T0LATCH () {	 &__IOMD(0x04c);}
}
unless(defined(&IOMD_T1CNTL)) {
    sub IOMD_T1CNTL () {	 &__IOMD(0x050);}
}
unless(defined(&IOMD_T1LTCHL)) {
    sub IOMD_T1LTCHL () {	 &__IOMD(0x050);}
}
unless(defined(&IOMD_T1CNTH)) {
    sub IOMD_T1CNTH () {	 &__IOMD(0x054);}
}
unless(defined(&IOMD_T1LTCHH)) {
    sub IOMD_T1LTCHH () {	 &__IOMD(0x054);}
}
unless(defined(&IOMD_T1GO)) {
    sub IOMD_T1GO () {	 &__IOMD(0x058);}
}
unless(defined(&IOMD_T1LATCH)) {
    sub IOMD_T1LATCH () {	 &__IOMD(0x05c);}
}
unless(defined(&IOMD_ROMCR0)) {
    sub IOMD_ROMCR0 () {	 &__IOMD(0x080);}
}
unless(defined(&IOMD_ROMCR1)) {
    sub IOMD_ROMCR1 () {	 &__IOMD(0x084);}
}
unless(defined(&IOMD_DRAMCR)) {
    sub IOMD_DRAMCR () {	 &__IOMD(0x088);}
}
unless(defined(&IOMD_VREFCR)) {
    sub IOMD_VREFCR () {	 &__IOMD(0x08c);}
}
unless(defined(&IOMD_FSIZE)) {
    sub IOMD_FSIZE () {	 &__IOMD(0x090);}
}
unless(defined(&IOMD_ID0)) {
    sub IOMD_ID0 () {	 &__IOMD(0x094);}
}
unless(defined(&IOMD_ID1)) {
    sub IOMD_ID1 () {	 &__IOMD(0x098);}
}
unless(defined(&IOMD_VERSION)) {
    sub IOMD_VERSION () {	 &__IOMD(0x09c);}
}
unless(defined(&IOMD_MOUSEX)) {
    sub IOMD_MOUSEX () {	 &__IOMD(0x0a0);}
}
unless(defined(&IOMD_MOUSEY)) {
    sub IOMD_MOUSEY () {	 &__IOMD(0x0a4);}
}
unless(defined(&IOMD_DMATCR)) {
    sub IOMD_DMATCR () {	 &__IOMD(0x0c0);}
}
unless(defined(&IOMD_IOTCR)) {
    sub IOMD_IOTCR () {	 &__IOMD(0x0c4);}
}
unless(defined(&IOMD_ECTCR)) {
    sub IOMD_ECTCR () {	 &__IOMD(0x0c8);}
}
unless(defined(&IOMD_DMAEXT)) {
    sub IOMD_DMAEXT () {	 &__IOMD(0x0cc);}
}
unless(defined(&DMA_EXT_IO0)) {
    sub DMA_EXT_IO0 () {	1;}
}
unless(defined(&DMA_EXT_IO1)) {
    sub DMA_EXT_IO1 () {	2;}
}
unless(defined(&DMA_EXT_IO2)) {
    sub DMA_EXT_IO2 () {	4;}
}
unless(defined(&DMA_EXT_IO3)) {
    sub DMA_EXT_IO3 () {	8;}
}
unless(defined(&IOMD_IO0CURA)) {
    sub IOMD_IO0CURA () {	 &__IOMD(0x100);}
}
unless(defined(&IOMD_IO0ENDA)) {
    sub IOMD_IO0ENDA () {	 &__IOMD(0x104);}
}
unless(defined(&IOMD_IO0CURB)) {
    sub IOMD_IO0CURB () {	 &__IOMD(0x108);}
}
unless(defined(&IOMD_IO0ENDB)) {
    sub IOMD_IO0ENDB () {	 &__IOMD(0x10c);}
}
unless(defined(&IOMD_IO0CR)) {
    sub IOMD_IO0CR () {	 &__IOMD(0x110);}
}
unless(defined(&IOMD_IO0ST)) {
    sub IOMD_IO0ST () {	 &__IOMD(0x114);}
}
unless(defined(&IOMD_IO1CURA)) {
    sub IOMD_IO1CURA () {	 &__IOMD(0x120);}
}
unless(defined(&IOMD_IO1ENDA)) {
    sub IOMD_IO1ENDA () {	 &__IOMD(0x124);}
}
unless(defined(&IOMD_IO1CURB)) {
    sub IOMD_IO1CURB () {	 &__IOMD(0x128);}
}
unless(defined(&IOMD_IO1ENDB)) {
    sub IOMD_IO1ENDB () {	 &__IOMD(0x12c);}
}
unless(defined(&IOMD_IO1CR)) {
    sub IOMD_IO1CR () {	 &__IOMD(0x130);}
}
unless(defined(&IOMD_IO1ST)) {
    sub IOMD_IO1ST () {	 &__IOMD(0x134);}
}
unless(defined(&IOMD_IO2CURA)) {
    sub IOMD_IO2CURA () {	 &__IOMD(0x140);}
}
unless(defined(&IOMD_IO2ENDA)) {
    sub IOMD_IO2ENDA () {	 &__IOMD(0x144);}
}
unless(defined(&IOMD_IO2CURB)) {
    sub IOMD_IO2CURB () {	 &__IOMD(0x148);}
}
unless(defined(&IOMD_IO2ENDB)) {
    sub IOMD_IO2ENDB () {	 &__IOMD(0x14c);}
}
unless(defined(&IOMD_IO2CR)) {
    sub IOMD_IO2CR () {	 &__IOMD(0x150);}
}
unless(defined(&IOMD_IO2ST)) {
    sub IOMD_IO2ST () {	 &__IOMD(0x154);}
}
unless(defined(&IOMD_IO3CURA)) {
    sub IOMD_IO3CURA () {	 &__IOMD(0x160);}
}
unless(defined(&IOMD_IO3ENDA)) {
    sub IOMD_IO3ENDA () {	 &__IOMD(0x164);}
}
unless(defined(&IOMD_IO3CURB)) {
    sub IOMD_IO3CURB () {	 &__IOMD(0x168);}
}
unless(defined(&IOMD_IO3ENDB)) {
    sub IOMD_IO3ENDB () {	 &__IOMD(0x16c);}
}
unless(defined(&IOMD_IO3CR)) {
    sub IOMD_IO3CR () {	 &__IOMD(0x170);}
}
unless(defined(&IOMD_IO3ST)) {
    sub IOMD_IO3ST () {	 &__IOMD(0x174);}
}
unless(defined(&IOMD_SD0CURA)) {
    sub IOMD_SD0CURA () {	 &__IOMD(0x180);}
}
unless(defined(&IOMD_SD0ENDA)) {
    sub IOMD_SD0ENDA () {	 &__IOMD(0x184);}
}
unless(defined(&IOMD_SD0CURB)) {
    sub IOMD_SD0CURB () {	 &__IOMD(0x188);}
}
unless(defined(&IOMD_SD0ENDB)) {
    sub IOMD_SD0ENDB () {	 &__IOMD(0x18c);}
}
unless(defined(&IOMD_SD0CR)) {
    sub IOMD_SD0CR () {	 &__IOMD(0x190);}
}
unless(defined(&IOMD_SD0ST)) {
    sub IOMD_SD0ST () {	 &__IOMD(0x194);}
}
unless(defined(&IOMD_SD1CURA)) {
    sub IOMD_SD1CURA () {	 &__IOMD(0x1a0);}
}
unless(defined(&IOMD_SD1ENDA)) {
    sub IOMD_SD1ENDA () {	 &__IOMD(0x1a4);}
}
unless(defined(&IOMD_SD1CURB)) {
    sub IOMD_SD1CURB () {	 &__IOMD(0x1a8);}
}
unless(defined(&IOMD_SD1ENDB)) {
    sub IOMD_SD1ENDB () {	 &__IOMD(0x1ac);}
}
unless(defined(&IOMD_SD1CR)) {
    sub IOMD_SD1CR () {	 &__IOMD(0x1b0);}
}
unless(defined(&IOMD_SD1ST)) {
    sub IOMD_SD1ST () {	 &__IOMD(0x1b4);}
}
unless(defined(&IOMD_CURSCUR)) {
    sub IOMD_CURSCUR () {	 &__IOMD(0x1c0);}
}
unless(defined(&IOMD_CURSINIT)) {
    sub IOMD_CURSINIT () {	 &__IOMD(0x1c4);}
}
unless(defined(&IOMD_VIDCUR)) {
    sub IOMD_VIDCUR () {	 &__IOMD(0x1d0);}
}
unless(defined(&IOMD_VIDEND)) {
    sub IOMD_VIDEND () {	 &__IOMD(0x1d4);}
}
unless(defined(&IOMD_VIDSTART)) {
    sub IOMD_VIDSTART () {	 &__IOMD(0x1d8);}
}
unless(defined(&IOMD_VIDINIT)) {
    sub IOMD_VIDINIT () {	 &__IOMD(0x1dc);}
}
unless(defined(&IOMD_VIDCR)) {
    sub IOMD_VIDCR () {	 &__IOMD(0x1e0);}
}
unless(defined(&IOMD_DMASTAT)) {
    sub IOMD_DMASTAT () {	 &__IOMD(0x1f0);}
}
unless(defined(&IOMD_DMAREQ)) {
    sub IOMD_DMAREQ () {	 &__IOMD(0x1f4);}
}
unless(defined(&IOMD_DMAMASK)) {
    sub IOMD_DMAMASK () {	 &__IOMD(0x1f8);}
}
unless(defined(&DMA_END_S)) {
    sub DMA_END_S () {	(1<< 31);}
}
unless(defined(&DMA_END_L)) {
    sub DMA_END_L () {	(1<< 30);}
}
unless(defined(&DMA_CR_C)) {
    sub DMA_CR_C () {	0x80;}
}
unless(defined(&DMA_CR_D)) {
    sub DMA_CR_D () {	0x40;}
}
unless(defined(&DMA_CR_E)) {
    sub DMA_CR_E () {	0x20;}
}
unless(defined(&DMA_ST_OFL)) {
    sub DMA_ST_OFL () {	4;}
}
unless(defined(&DMA_ST_INT)) {
    sub DMA_ST_INT () {	2;}
}
unless(defined(&DMA_ST_AB)) {
    sub DMA_ST_AB () {	1;}
}
unless(defined(&IOC_CONTROL)) {
    eval 'sub IOC_CONTROL () { &IOMD_CONTROL;}' unless defined(&IOC_CONTROL);
    eval 'sub IOC_IRQSTATA () { &IOMD_IRQSTATA;}' unless defined(&IOC_IRQSTATA);
    eval 'sub IOC_IRQREQA () { &IOMD_IRQREQA;}' unless defined(&IOC_IRQREQA);
    eval 'sub IOC_IRQCLRA () { &IOMD_IRQCLRA;}' unless defined(&IOC_IRQCLRA);
    eval 'sub IOC_IRQMASKA () { &IOMD_IRQMASKA;}' unless defined(&IOC_IRQMASKA);
    eval 'sub IOC_IRQSTATB () { &IOMD_IRQSTATB;}' unless defined(&IOC_IRQSTATB);
    eval 'sub IOC_IRQREQB () { &IOMD_IRQREQB;}' unless defined(&IOC_IRQREQB);
    eval 'sub IOC_IRQMASKB () { &IOMD_IRQMASKB;}' unless defined(&IOC_IRQMASKB);
    eval 'sub IOC_FIQSTAT () { &IOMD_FIQSTAT;}' unless defined(&IOC_FIQSTAT);
    eval 'sub IOC_FIQREQ () { &IOMD_FIQREQ;}' unless defined(&IOC_FIQREQ);
    eval 'sub IOC_FIQMASK () { &IOMD_FIQMASK;}' unless defined(&IOC_FIQMASK);
    eval 'sub IOC_T0CNTL () { &IOMD_T0CNTL;}' unless defined(&IOC_T0CNTL);
    eval 'sub IOC_T0LTCHL () { &IOMD_T0LTCHL;}' unless defined(&IOC_T0LTCHL);
    eval 'sub IOC_T0CNTH () { &IOMD_T0CNTH;}' unless defined(&IOC_T0CNTH);
    eval 'sub IOC_T0LTCHH () { &IOMD_T0LTCHH;}' unless defined(&IOC_T0LTCHH);
    eval 'sub IOC_T0GO () { &IOMD_T0GO;}' unless defined(&IOC_T0GO);
    eval 'sub IOC_T0LATCH () { &IOMD_T0LATCH;}' unless defined(&IOC_T0LATCH);
    eval 'sub IOC_T1CNTL () { &IOMD_T1CNTL;}' unless defined(&IOC_T1CNTL);
    eval 'sub IOC_T1LTCHL () { &IOMD_T1LTCHL;}' unless defined(&IOC_T1LTCHL);
    eval 'sub IOC_T1CNTH () { &IOMD_T1CNTH;}' unless defined(&IOC_T1CNTH);
    eval 'sub IOC_T1LTCHH () { &IOMD_T1LTCHH;}' unless defined(&IOC_T1LTCHH);
    eval 'sub IOC_T1GO () { &IOMD_T1GO;}' unless defined(&IOC_T1GO);
    eval 'sub IOC_T1LATCH () { &IOMD_T1LATCH;}' unless defined(&IOC_T1LATCH);
}
unless(defined(&HALF_SAM)) {
    sub HALF_SAM () {	 &vram_half_sam;}
}
unless(defined(&VDMA_ALIGNMENT)) {
    sub VDMA_ALIGNMENT () {	( &HALF_SAM * 2);}
}
unless(defined(&VDMA_XFERSIZE)) {
    sub VDMA_XFERSIZE () {	( &HALF_SAM);}
}
unless(defined(&VDMA_INIT)) {
    sub VDMA_INIT () {	 &IOMD_VIDINIT;}
}
unless(defined(&VDMA_START)) {
    sub VDMA_START () {	 &IOMD_VIDSTART;}
}
unless(defined(&VDMA_END)) {
    sub VDMA_END () {	 &IOMD_VIDEND;}
}
unless(defined(&__ASSEMBLY__)) {
    eval 'sub video_set_dma {
        local($start,$end,$offset) = @_;
	    eval q( &do {  &outl ( &SCREEN_START + $start,  &VDMA_START);  &outl ( &SCREEN_START + $end -  &VDMA_XFERSIZE,  &VDMA_END);  &if ($offset >= $end -  &VDMA_XFERSIZE) $offset |= 0x40000000;  &outl ( &SCREEN_START + $offset,  &VDMA_INIT); }  &while (0));
    }' unless defined(&video_set_dma);
}
1;
