require '_h2ph_pre.ph';

unless(defined(&__ASM_ARM_PROCESSOR_H)) {
    eval 'sub __ASM_ARM_PROCESSOR_H () {1;}' unless defined(&__ASM_ARM_PROCESSOR_H);
    eval 'sub FP_SIZE () {35;}' unless defined(&FP_SIZE);
    if(defined(&__KERNEL__)) {
	eval 'sub NR_DEBUGS () {5;}' unless defined(&NR_DEBUGS);
	require 'asm/ptrace.ph';
	require 'asm/arch/processor.ph';
	require 'asm/proc/processor.ph';
	eval 'sub INIT_MMAP () {{  &init_mm, 0, 0,  &NULL,  &PAGE_SHARED,  &VM_READ |  &VM_WRITE |  &VM_EXEC, 1,  &NULL,  &NULL };}' unless defined(&INIT_MMAP);
	eval 'sub INIT_TSS () {{ 0, 0, 0, { { { 0, }, }, }, { 0, }, 0,  &SWAPPER_PG_DIR  &EXTRA_THREAD_STRUCT_INIT };}' unless defined(&INIT_TSS);
	eval 'sub copy_segments {
	    local($nr, $tsk, $mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&copy_segments);
	eval 'sub release_segments {
	    local($mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&release_segments);
	eval 'sub forget_segments () {
	    eval q( &do { }  &while (0));
	}' unless defined(&forget_segments);
	eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
    }
}
1;
