require '_h2ph_pre.ph';

unless(defined(&_ASMARM_UACCESS_H)) {
    eval 'sub _ASMARM_UACCESS_H () {1;}' unless defined(&_ASMARM_UACCESS_H);
    require 'linux/sched.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    require 'asm/proc/uaccess.ph';
    eval 'sub get_user {
        local($x,$p) = @_;
	    eval q( &__get_user_check(($x),($p),$sizeof{($p)}));
    }' unless defined(&get_user);
    eval 'sub __get_user {
        local($x,$p) = @_;
	    eval q( &__get_user_nocheck(($x),($p),$sizeof{($p)}));
    }' unless defined(&__get_user);
    eval 'sub get_user_ret {
        local($x,$p,$r) = @_;
	    eval q(({  &if ( &get_user($x,$p))  &return $r; }));
    }' unless defined(&get_user_ret);
    eval 'sub __get_user_ret {
        local($x,$p,$r) = @_;
	    eval q(({  &if ( &__get_user($x,$p))  &return $r; }));
    }' unless defined(&__get_user_ret);
    eval 'sub __get_user3 {
        local($x,$p,$l) = @_;
	    eval q( &__get_user3_nocheck(($x),($p),$sizeof{($p)},$l));
    }' unless defined(&__get_user3);
    eval 'sub __get_kernel {
        local($x,$p) = @_;
	    eval q( &__get_kernel_nocheck(($x),($p),$sizeof{($p)}));
    }' unless defined(&__get_kernel);
    eval 'sub __get_kernel3 {
        local($x,$p,$l) = @_;
	    eval q( &__get_kernel3_nocheck(($x),($p),$sizeof{($p)},$l));
    }' unless defined(&__get_kernel3);
    eval 'sub put_user {
        local($x,$p) = @_;
	    eval q( &__put_user_check(( &__typeof(*($p)))($x),($p),$sizeof{($p)}));
    }' unless defined(&put_user);
    eval 'sub __put_user {
        local($x,$p) = @_;
	    eval q( &__put_user_nocheck(( &__typeof(*($p)))($x),($p),$sizeof{($p)}));
    }' unless defined(&__put_user);
    eval 'sub put_user_ret {
        local($x,$p,$r) = @_;
	    eval q(({  &if ( &put_user($x,$p))  &return $r; }));
    }' unless defined(&put_user_ret);
    eval 'sub __put_user_ret {
        local($x,$p,$r) = @_;
	    eval q(({  &if ( &__put_user($x,$p))  &return $r; }));
    }' unless defined(&__put_user_ret);
    eval 'sub __put_kernel {
        local($x,$p) = @_;
	    eval q( &__put_kernel_nocheck(( &__typeof(*($p)))($x),($p),$sizeof{($p)}));
    }' unless defined(&__put_kernel);
    eval 'sub copy_from_user_ret {
        local($t,$f,$n,$r) = @_;
	    eval q(({  &if ( &copy_from_user($t,$f,$n))  &return $r; }));
    }' unless defined(&copy_from_user_ret);
    eval 'sub copy_to_user_ret {
        local($t,$f,$n,$r) = @_;
	    eval q(({  &if ( &copy_to_user($t,$f,$n))  &return $r; }));
    }' unless defined(&copy_to_user_ret);
    eval 'sub strlen_user {
        local($s) = @_;
	    eval q( &strnlen_user($s, ~0 >> 1));
    }' unless defined(&strlen_user);
    eval 'sub __get_user_check {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\' = - &EFAULT,  &__gu_val;  &const  &__typeof__(*($ptr)) * &__gu_addr = ($ptr);  &if ( &access_ok( &VERIFY_READ, &__gu_addr,$size))  &__get_user_size( &__gu_val, &__gu_addr,($size), &__gu_err);  &else  &__gu_val = 0; ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_check);
    eval 'sub __get_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\' = 0,  &__gu_val;  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user3_nocheck {
        local($x,$ptr,$size,$lab) = @_;
	    eval q(({ \'long __gu_err\' = 0,  &__gu_val;  &__get_user3_size( &__gu_val,($ptr),($size),$lab); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user3_nocheck);
    eval 'sub __get_kernel_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\' = 0,  &__gu_val;  &__get_kernel_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_kernel_nocheck);
    eval 'sub __get_kernel3_nocheck {
        local($x,$ptr,$size,$lab) = @_;
	    eval q(({ \'long __gu_err\' = 0,  &__gu_val;  &__get_kernel3_size( &__gu_val,($ptr),($size),$lab); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_kernel3_nocheck);
    eval 'sub __put_user_check {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\' = - &EFAULT;  &__typeof__(*($ptr)) * &__pu_addr = ($ptr);  &if ( &access_ok( &VERIFY_WRITE, &__pu_addr,$size))  &__put_user_size(($x), &__pu_addr,($size), &__pu_err);  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\' = 0;  &__put_user_size(($x),($ptr),($size), &__pu_err);  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __get_user_size {
        local($x,$ptr,$size,$retval) = @_;
	    eval q( &do { $retval = 0;  &switch ($size) {  &case 1:  &__get_user_asm_byte($x,$ptr,$retval);  &break;  &case 2:  &__get_user_asm_half($x,$ptr,$retval);  &break;  &case 4:  &__get_user_asm_word($x,$ptr,$retval);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user_size);
    eval 'sub __get_kernel_size {
        local($x,$ptr,$size,$retval) = @_;
	    eval q( &do { $retval = 0;  &switch ($size) {  &case 1:  &__get_kernel_asm_byte($x,$ptr,$retval);  &break;  &case 2:  &__get_kernel_asm_half($x,$ptr,$retval);  &break;  &case 4:  &__get_kernel_asm_word($x,$ptr,$retval);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_kernel_size);
    eval 'sub __get_user3_size {
        local($x,$ptr,$size,$lab) = @_;
	    eval q( &do {  &switch ($size) {  &case 4:  &__get_user3_asm_word($x,$ptr,$lab);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user3_size);
    eval 'sub __get_kernel3_size {
        local($x,$ptr,$size,$lab) = @_;
	    eval q( &do {  &switch ($size) {  &case 4:  &__get_kernel3_asm_word($x,$ptr,$lab);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_kernel3_size);
    eval 'sub __put_user_size {
        local($x,$ptr,$size,$retval) = @_;
	    eval q( &do { $retval = 0;  &switch ($size) {  &case 1:  &__put_user_asm_byte($x,$ptr,$retval);  &break;  &case 2:  &__put_user_asm_half($x,$ptr,$retval);  &break;  &case 4:  &__put_user_asm_word($x,$ptr,$retval);  &break;  &default:  &__put_user_bad(); } }  &while (0));
    }' unless defined(&__put_user_size);
}
1;
